<?php

function phpAds_InstallMessage($title, $message)
{
?>
<br><br>
		<table border='0' cellpadding='1' cellspacing='1' width='100%'><tr><td bgcolor='#0033FF'>
			
      <table border='0' cellpadding='5' cellspacing='0' width='100%'>
        <tr bgcolor='#F7F7F7'> 
          <td width='20' valign='top'><img src='images/info-w.gif' hspace='3'></td>
          <td valign='top' bgcolor="#F7F7F7"><b> </b> 
            <table width="100%" border="0" cellspacing="0" cellpadding="0">
              <tr> 
                <td height="18" valign="top"><b> 
                  <?php echo $title;?>
                  </b></td>
              </tr>
              <tr> 
                <td height="3" valign="top"><img src="images/break-l.gif" width="100%" height="1"></td>
              </tr>
              <tr> 
                <td><br>
                  <?php echo $message;?>
                  <br>
                  &nbsp;</td>
              </tr>
            </table>
          </td>
        </tr>
      </table>
		</td></tr></table>
<?php
}



/*********************************************************/
/* Create db structure from 'all.sql'                    */
/*********************************************************/

function phpAds_create_db_structure()
{
	global $phpAds_version, $phpAds_config;
	
	$allsql = join("", file(phpAds_path."/misc/all.sql"));
	
	// Stripping comments
	$allsql = ereg_replace("-- [^\n]*\n", "\n", $allsql);
	
	// Removing BEGIN/COMMIT
	$allsql = eregi_replace("(BEGIN|COMMIT);", "", $allsql);
	
	// Stripping (CR)LFs
	$allsql = str_replace("\r?\n\r?", "", $allsql);
	
	// Unifying duplicate blanks
	$allsql = ereg_replace("[[:blank:]]+", " ", $allsql);
	
	// Replacing table names to match config.inc.php
	$allsql = str_replace('phpads_clients', $phpAds_config['tbl_clients'], $allsql);
	$allsql = str_replace('phpads_banners', $phpAds_config['tbl_banners'], $allsql);
	$allsql = str_replace('phpads_adstats', $phpAds_config['tbl_adstats'], $allsql);
	$allsql = str_replace('phpads_adviews', $phpAds_config['tbl_adviews'], $allsql);
	$allsql = str_replace('phpads_adclicks', $phpAds_config['tbl_adclicks'], $allsql);
	$allsql = str_replace('phpads_acls', $phpAds_config['tbl_acls'], $allsql);
	$allsql = str_replace('phpads_session', $phpAds_config['tbl_session'], $allsql);
	$allsql = str_replace('phpads_zones', $phpAds_config['tbl_zones'], $allsql);
	$allsql = str_replace('phpads_config', $phpAds_config['tbl_config'], $allsql);
	
//	$allsql = ereg_replace("(TABLE |'|REFERENCES )phpads_([a-z])", "\\1".$phpAds_config['tbl_prefix']."\\2", $allsql);

	// Split statements
	$allsql = explode(";", $allsql);
	
	$functions = array(
		new phpAds_sql_function('unix_timestamp',
			'timestamp',
			'int8',
			'SELECT (CASE WHEN $1 = NULL
				THEN 0
				ELSE date_part(\'epoch\', $1) END)::int8'),
		new phpAds_sql_function('to_days',
			'timestamp',
			'int8',
			'SELECT floor(CASE WHEN $1 = NULL
				THEN 0
				ELSE unix_timestamp($1)/86400 END)::int8'),
		new phpAds_sql_function('dayofmonth',
			'timestamp',
			'int2',
			'SELECT date_part(\'day\', $1)::int2'),
		new phpAds_sql_function('month',
			'timestamp',
			'int2',
			'SELECT date_part(\'month\', $1)::int2'),
		new phpAds_sql_function('year',
			'timestamp',
			'int4',
			'SELECT date_part(\'year\', $1)::int4'),
		new phpAds_sql_function('week',
			'timestamp',
			'int2',
			'SELECT date_part(\'week\', $1)::int2'),
		new phpAds_sql_function('date_format',
			'timestamp, text',
			'text',
			'SELECT CASE WHEN $1 = NULL THEN \'\' ELSE to_char($1, $2) END'),
		new phpAds_sql_function('if',
			'bool, varchar, varchar',
			'varchar',
			'SELECT CASE WHEN $1 THEN $2 ELSE $3 END'),
		new phpAds_sql_function('phpads_ww',
			'int4, timestamp',
			'text',
			'SELECT to_char(week($2 + ((1 - $1) || \' day\')::interval)::int,
				\'FM00\'::text)'),
		new phpAds_sql_function('phpads_yyyy',
			'int4, timestamp',
			'text',
			'SELECT CASE
				WHEN week($2 + ((1 - $1) || \' day\')::interval) >= 52
					AND month($2) = 1 THEN to_char(year($2)-1, \'FM0000\')
				WHEN week($2 + ((1 - $1) || \' day\')::interval) = 1
					AND month($2) = 12 THEN to_char(year($2)+1, \'FM0000\')
				ELSE to_char(year($2), \'FM0000\')
				END'));
	
	$message = array();
	
	$max_version = phpAds_dbResult(phpAds_dbQuery("SELECT version FROM phpads_versioncheck"), 0, 0);
		
	$overwrite_functions = $max_version < $phpAds_version;
	
	phpAds_dbQuery("BEGIN") or phpAds_sqlDie();
	
	while (list(, $sql) = each($allsql))
	{
		$sql = trim($sql);
		if (!eregi("[a-z]", $sql))
			continue;
		if (eregi("^create table ([a-z_]+)", $sql, $matches))
			$formatstr = $GLOBALS['strTableCreated'];
		elseif (eregi("^create sequence ([a-z_]+)", $sql, $matches))
			$formatstr = $GLOBALS['strSequenceCreated'];
		elseif (eregi("^create index ([a-z_]+)", $sql, $matches))
			$formatstr = $GLOBALS['strIndexCreated'];
		elseif (eregi("^create function", $sql, $matches))
			phpAds_Die($GLOBALS['strError'], $GLOBALS['strFunctionInAllDotSqlErr']);
		else
			$formatstr = $GLOBALS['strUnknownStatementExec'];
		
		phpAds_dbQuery($sql) or phpAds_sqlDie();
		$message[] = sprintf($formatstr.'.', $matches[1]);
	}
	
	if (!empty($max_version) && $overwrite_functions)
		phpAds_dbQuery("UPDATE phpads_versioncheck SET version = $phpAds_version") or phpAds_sqlDie();
	elseif (empty($max_version))
		phpAds_dbQuery('SELECT '.$phpAds_version.'::float AS version INTO phpads_versioncheck') or phpAds_sqlDie();
	
	phpAds_dbQuery("COMMIT") or phpAds_sqlDie();
	phpAds_dbQuery("BEGIN") or phpAds_sqlDie();
	
	while (list(, $sqlfunc) = each($functions))
	{
		$formatstr = '';

		if ($sqlfunc->exists())
		{
			if ($overwrite_functions)
			{
				$sqlfunc->drop() or phpAds_sqlDie();
				$sqlfunc->create() or phpAds_sqlDie();
				$formatstr = $GLOBALS['strFunctionReplaced'];
			}
		}
		else
		{
			$sqlfunc->create() or phpAds_sqlDie();
			$formatstr = $GLOBALS['strFunctionCreated'];
		}
		
		if (!empty($formatstr))
			$message[] = sprintf($formatstr.'.', $sqlfunc->get_name());
	}
	
	phpAds_dbQuery("COMMIT") or phpAds_sqlDie();

	return join("<br>", $message);
}



/*********************************************************/
/* SQL function class - phpPgAds only                    */
/*********************************************************/

class phpAds_sql_function
{
	var $name, $args, $returns, $as, $language;
	
	function phpAds_sql_function($name, $args, $returns, $as, $language = 'sql')
	{
	$this->name = $name;
	$this->args = split(", *",$args);
	$this->returns = $returns;
	$this->as = $as;
	$this->language = $language;
	}
	
	function create()
	{
	return phpAds_dbQuery("CREATE FUNCTION $this->name (".join(", ", $this->args).")".
		"RETURNS $this->returns AS '".
		str_replace("'", "\'", $this->as)."' LANGUAGE '$this->language'");
	}

	function exists()
	{
	$res = phpAds_dbQuery("SELECT 
					pc.oid,
					proname, 
					pt.typname AS result, 
					'|' || oidvectortypes(pc.proargtypes) || '|' AS arguments
				FROM 
					pg_proc pc, pg_user pu, pg_type pt
				WHERE
					pc.proowner = pu.usesysid
					AND pc.prorettype = pt.oid
					AND proname = '$this->name'");
	
	return phpAds_dbNumRows($res);
	}
	
	function drop()
	{
	return phpAds_dbQuery("DROP FUNCTION $this->name (".join(", ", $this->args).")");
	}	

	function get_name()
	{
	return "$this->name"; //(".join(", ", $this->args).")";
	}	
}

?>
